<?php

/*
		Généalogik
		
        Class for table : document.

        07/03/2021 10:45

        lvardon@laposte.net - 2021
        
        Licence libre

        Usage examples :

        <?php

            include_once("classdir/dbconnect.php);
            include_once("classdir/class_document.php);

            // Class instance
            $mydocument = document( $db );

            // Select all reccords :
            $results = $mydocument->selectAll();
            foreach($results as $row) {
                print_r($row);
            } 

            // Select reccord #12 :
            $id = 12;
            $row = $mydocument->select($id);
            print_r($row);

        ?>

*/
class _document {
      
    public $db;
    public $lasterror="";
    public $lastInsertId=-1;
    public $count = 0;
  
    /*
        Initialise object with dbHanler.
                
    */    
    function __construct( $db ) {
        $this->db = $db;
    }

    /*
        Select one reccord from document.
        
        parameters : $id (reccord id).
        return : associative array of reccord.
    */
    function select($id) {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.name as 'a.name',
			a.description as 'a.description',
			a.private as 'a.private',
			a.icon as 'a.icon',
			a.url as 'a.url',
			a.cote as 'a.cote',
			a.notesearch as 'a.notesearch',
			a.datecreated as 'a.datecreated',
			a.depot_id as 'a.depot_id',
			a.documenttype_id as 'a.documenttype_id',

 			b1.id as 'b1.id', 
 			b1.name as 'b1.name', 
 			b1.code as 'b1.code', 
 			b1.description as 'b1.description', 
 			b1.icon as 'b1.icon', 
 			b1.url as 'b1.url', 
 			b1.adress_1 as 'b1.adress_1', 
 			b1.adress_2 as 'b1.adress_2', 
 			b1.city as 'b1.city', 
 			b1.zip as 'b1.zip', 
 			b1.country as 'b1.country', 
 			c2.id as 'c2.id', 
 			c2.name as 'c2.name', 
 			c2.code as 'c2.code', 
 			c2.description as 'c2.description', 
 			c2.icon as 'c2.icon' 

		from document a 
 			left outer join documenttype c2 on c2.id =  a.documenttype_id 
 			left outer join depot b1 on b1.id =  a.depot_id 

		where a.id = :id; 
			";

        try {        		

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$idkeyname.')';
            return false;
        }
    }

    function selectPrev($id) {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.name as 'a.name',
			a.description as 'a.description',
			a.private as 'a.private',
			a.icon as 'a.icon',
			a.url as 'a.url',
			a.cote as 'a.cote',
			a.notesearch as 'a.notesearch',
			a.datecreated as 'a.datecreated',
			a.depot_id as 'a.depot_id',
			a.documenttype_id as 'a.documenttype_id',

 			b1.id as 'b1.id', 
 			b1.name as 'b1.name', 
 			b1.code as 'b1.code', 
 			b1.description as 'b1.description', 
 			b1.icon as 'b1.icon', 
 			b1.url as 'b1.url', 
 			b1.adress_1 as 'b1.adress_1', 
 			b1.adress_2 as 'b1.adress_2', 
 			b1.city as 'b1.city', 
 			b1.zip as 'b1.zip', 
 			b1.country as 'b1.country', 
 			c2.id as 'c2.id', 
 			c2.name as 'c2.name', 
 			c2.code as 'c2.code', 
 			c2.description as 'c2.description', 
 			c2.icon as 'c2.icon' 

		from document a 
 			left outer join documenttype c2 on c2.id =  a.documenttype_id 
 			left outer join depot b1 on b1.id =  a.depot_id 

		where a.id =  (SELECT id FROM document WHERE id < :id ORDER BY id DESC LIMIT 1) ; 
			";

        try {        		

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$idkeyname.')';
            return false;
        }
    }


    function selectNext($id) {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.name as 'a.name',
			a.description as 'a.description',
			a.private as 'a.private',
			a.icon as 'a.icon',
			a.url as 'a.url',
			a.cote as 'a.cote',
			a.notesearch as 'a.notesearch',
			a.datecreated as 'a.datecreated',
			a.depot_id as 'a.depot_id',
			a.documenttype_id as 'a.documenttype_id',

 			b1.id as 'b1.id', 
 			b1.name as 'b1.name', 
 			b1.code as 'b1.code', 
 			b1.description as 'b1.description', 
 			b1.icon as 'b1.icon', 
 			b1.url as 'b1.url', 
 			b1.adress_1 as 'b1.adress_1', 
 			b1.adress_2 as 'b1.adress_2', 
 			b1.city as 'b1.city', 
 			b1.zip as 'b1.zip', 
 			b1.country as 'b1.country', 
 			c2.id as 'c2.id', 
 			c2.name as 'c2.name', 
 			c2.code as 'c2.code', 
 			c2.description as 'c2.description', 
 			c2.icon as 'c2.icon' 

		from document a 
 			left outer join documenttype c2 on c2.id =  a.documenttype_id 
 			left outer join depot b1 on b1.id =  a.depot_id 

		where a.id =  (SELECT id FROM document WHERE id > :id ORDER BY id ASC LIMIT 1) ; 
			";

        try {        		

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$idkeyname.')';
            return false;
        }
    }

    /*
        Select all reccords from document  (with default order).
        
        parameters : None
        return : associative array of reccords.
    */
    function selectAll() {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.name as 'a.name',
			a.description as 'a.description',
			a.private as 'a.private',
			a.icon as 'a.icon',
			a.url as 'a.url',
			a.cote as 'a.cote',
			a.notesearch as 'a.notesearch',
			a.datecreated as 'a.datecreated',
			a.depot_id as 'a.depot_id',
			a.documenttype_id as 'a.documenttype_id',

 			b1.id as 'b1.id',
 			b1.name as 'b1.name',
 			b1.code as 'b1.code',
 			b1.description as 'b1.description',
 			b1.icon as 'b1.icon',
 			b1.url as 'b1.url',
 			b1.adress_1 as 'b1.adress_1',
 			b1.adress_2 as 'b1.adress_2',
 			b1.city as 'b1.city',
 			b1.zip as 'b1.zip',
 			b1.country as 'b1.country',
 			c2.id as 'c2.id',
 			c2.name as 'c2.name',
 			c2.code as 'c2.code',
 			c2.description as 'c2.description',
 			c2.icon as 'c2.icon'

		from document a 
 			left outer join documenttype c2 on c2.id =  a.documenttype_id 
 			left outer join depot b1 on b1.id =  a.depot_id 

		;    
                ";

        try {        

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);           
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage();
            $this->count = 0;
            return false;
        }
    }

    /*
        Update document 
        
        parameters : $id (reccord id) and fields list values.
        return : True if no error.
    */
    function update( $id, $name,$description,$private,$icon,$url,$cote,$notesearch,$datecreated,$depot_id,$documenttype_id ) {

        $this->lasterror="";        

		if ($name == '') $name = null;
		if ($description == '') $description = null;
		if ($private == '') $private = null;
		if ($icon == '') $icon = null;
		if ($url == '') $url = null;
		if ($cote == '') $cote = null;
		if ($notesearch == '') $notesearch = null;
		if ($datecreated == '') $datecreated = null;
		if ($depot_id == '') $depot_id = null;
		if ($documenttype_id == '') $documenttype_id = null;
		

        if ($this->checkValue( array( 
		$name => '',
		$description => '',
		$private => '',
		$icon => '',
		$url => '',
		$cote => '',
		$notesearch => '',
		$datecreated => '',
		$depot_id => '',
		$documenttype_id => ''

) ) == false )
        {
            $this->lasterror="Check fields false";        
            return false;
        }

        $sqlSt="
		update document set
			name = :name,
			description = :description,
			private = :private,
			icon = :icon,
			url = :url,
			cote = :cote,
			notesearch = :notesearch,
			datecreated = :datecreated,
			depot_id = :depot_id,
			documenttype_id = :documenttype_id

		where id = :id; 
            ";

        try {        
            
            $stmt = $this->db->prepare($sqlSt);
            
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);

			$stmt->bindParam(':name', $name, PDO::PARAM_STR); 
			$stmt->bindParam(':description', $description, PDO::PARAM_STR); 
			$stmt->bindParam(':private', $private, PDO::PARAM_INT); 
			$stmt->bindParam(':icon', $icon, PDO::PARAM_STR); 
			$stmt->bindParam(':url', $url, PDO::PARAM_STR); 
			$stmt->bindParam(':cote', $cote, PDO::PARAM_STR); 
			$stmt->bindParam(':notesearch', $notesearch, PDO::PARAM_STR); 
			$stmt->bindParam(':datecreated', $datecreated, PDO::PARAM_STR); 
			$stmt->bindParam(':depot_id', $depot_id, PDO::PARAM_INT); 
			$stmt->bindParam(':documenttype_id', $documenttype_id, PDO::PARAM_INT); 
 
            $stmt->execute();             
            
            if ($stmt->rowCount() == 0) {
				$this->lasterror = 'Erreur Sql update '.'  (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>name</b> = [$name],<b>description</b> = [$description],<b>private</b> = [$private],<b>icon</b> = [$icon],<b>url</b> = [$url],<b>cote</b> = [$cote],<b>notesearch</b> = [$notesearch],<b>datecreated</b> = [$datecreated],<b>depot_id</b> = [$depot_id],<b>documenttype_id</b> = [$documenttype_id]";
				
				return false;
			}   
			         
            return true;

        } catch (Exception $e) {            
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>name</b> = [$name],<b>description</b> = [$description],<b>private</b> = [$private],<b>icon</b> = [$icon],<b>url</b> = [$url],<b>cote</b> = [$cote],<b>notesearch</b> = [$notesearch],<b>datecreated</b> = [$datecreated],<b>depot_id</b> = [$depot_id],<b>documenttype_id</b> = [$documenttype_id]";  
            return false;
        }

    }

    /*
        Insert new reccord into document.
        
        Parameters : fields values list.
        return : True if no error.
    */
    function insert( $name,$description,$private,$icon,$url,$cote,$notesearch,$datecreated,$depot_id,$documenttype_id ) {

        $this->lasterror="";
        $this->lastInsertId = -1;

		if ($name == '') $name = null;
		if ($description == '') $description = null;
		if ($private == '') $private = null;
		if ($icon == '') $icon = null;
		if ($url == '') $url = null;
		if ($cote == '') $cote = null;
		if ($notesearch == '') $notesearch = null;
		if ($datecreated == '') $datecreated = null;
		if ($depot_id == '') $depot_id = null;
		if ($documenttype_id == '') $documenttype_id = null;
		
		
        if ($this->checkValue( array( 
		$name => '',
		$description => '',
		$private => '',
		$icon => '',
		$url => '',
		$cote => '',
		$notesearch => '',
		$datecreated => '',
		$depot_id => '',
		$documenttype_id => ''

) ) == false )
        {
            $this->lasterror="Check fields error";        
            return false;
        }

        $sqlSt="
		insert into document (
		name,
		description,
		private,
		icon,
		url,
		cote,
		notesearch,
		datecreated,
		depot_id,
		documenttype_id
 
			)
		values (
		:name, 
		:description, 
		:private, 
		:icon, 
		:url, 
		:cote, 
		:notesearch, 
		:datecreated, 
		:depot_id, 
		:documenttype_id 
 
			);    
            ";

        try {        

            $stmt = $this->db->prepare($sqlSt);               
			
			$stmt->bindParam(':name', $name, PDO::PARAM_STR); 
			$stmt->bindParam(':description', $description, PDO::PARAM_STR); 
			$stmt->bindParam(':private', $private, PDO::PARAM_INT); 
			$stmt->bindParam(':icon', $icon, PDO::PARAM_STR); 
			$stmt->bindParam(':url', $url, PDO::PARAM_STR); 
			$stmt->bindParam(':cote', $cote, PDO::PARAM_STR); 
			$stmt->bindParam(':notesearch', $notesearch, PDO::PARAM_STR); 
			$stmt->bindParam(':datecreated', $datecreated, PDO::PARAM_STR); 
			$stmt->bindParam(':depot_id', $depot_id, PDO::PARAM_INT); 
			$stmt->bindParam(':documenttype_id', $documenttype_id, PDO::PARAM_INT); 
 

            $stmt->execute();     
            $this->lastInsertId = $this->db->lastInsertId(); 
            
            if ($stmt->rowCount() == 0) {
				$this->lasterror = 'Erreur Sql insert'.'  (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>name</b> = [$name],<b>description</b> = [$description],<b>private</b> = [$private],<b>icon</b> = [$icon],<b>url</b> = [$url],<b>cote</b> = [$cote],<b>notesearch</b> = [$notesearch],<b>datecreated</b> = [$datecreated],<b>depot_id</b> = [$depot_id],<b>documenttype_id</b> = [$documenttype_id]";
				return false;
			}              
                   
            return true;

        } catch (Exception $e) {
             $this->lasterror = $e->getMessage().'  (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>name</b> = [$name],<b>description</b> = [$description],<b>private</b> = [$private],<b>icon</b> = [$icon],<b>url</b> = [$url],<b>cote</b> = [$cote],<b>notesearch</b> = [$notesearch],<b>datecreated</b> = [$datecreated],<b>depot_id</b> = [$depot_id],<b>documenttype_id</b> = [$documenttype_id]";
            return false;
        }
    }

    /*
        Delete one reccord from document.
        
        parameters : $id (reccord id).
        return : True if no error.
    */
    function delete($id) {

        $this->lasterror="";

        $sqlSt="
		delete from document             
		where id = :id; 
            ";   
     
        try {        

            $stmt = $this->db->prepare($sqlSt);  
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute();        
            
			if ($stmt->rowCount() == 0) {
				$this->lasterror = "Erreur Sql delete ".' (<b>Id</b> ='.$id.')';       
				return false;
			}              

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b>='.$id.')';
            return false;
        }
        return true;
    }

    /*
        Get id min, id max, record count from document  
        
        parameters : None
        return : count value or False in case of error
    */
	function getCount() {
		
        $this->lasterror="";

        $sqlSt="
		select min(id) as minid, max(id) as maxid, count(*) as count 
		from document 
                ";

        try {        

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC); 
            return $results[0];          

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage();
            return array( 'minid' => -1, 'maxid' => -1, 'count' => -1);
        }
        		
		//return $this->count;
		return $results[0];
	}




	public $colmeta = [
	'a.id' => array (
		'metades' => "",
		'sortformat' => "{{sortformat}}",
		'listlen' => 4,
		'listlib' => 'id',
		'listlink' => 'on',
		'selectlen' => 4,
		'selectlib' => 'id',
		'selectlink' => 'on',
		'selectdisplay' => '',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => '', 
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 

		),
	'a.name' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 12,
		'listlib' => 'name' , 
		'listlink' => '',
		'selectlen' => 12,
		'selectlib' => 'name' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.description' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'description' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'description' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.private' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 4,
		'listlib' => 'private' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'private' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.icon' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 12,
		'listlib' => 'icon' , 
		'listlink' => '',
		'selectlen' => 12,
		'selectlib' => 'icon' , 
		'selectlink' => '',
		'selectdisplay' => 'urlpic',
		'selectdisplaywidth' => '{{selectdisplaywidth}}', 
		'selectdisplayheight' => '{{selectdisplayheight}}', 
		'listdisplay' => 'urlpic',
		'listdisplaywidth' => '{{listdisplaywidth}}', 
		'listdisplayheight' => '{{listdisplayheight}}' 
),
	'a.url' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 12,
		'listlib' => 'url' , 
		'listlink' => '',
		'selectlen' => 12,
		'selectlib' => 'url' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'url',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.cote' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 12,
		'listlib' => 'cote' , 
		'listlink' => '',
		'selectlen' => 12,
		'selectlib' => 'cote' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.notesearch' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 12,
		'listlib' => 'notesearch' , 
		'listlink' => '',
		'selectlen' => 12,
		'selectlib' => 'notesearch' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.datecreated' => array ( 
		'metades' => "",
		'sortformat' => "date", 
		'listlen' => 4,
		'listlib' => 'datecreated' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'datecreated' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.depot_id' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 4,
		'listlib' => 'depot_id' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'depot_id' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.documenttype_id' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 4,
		'listlib' => 'documenttype_id' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'documenttype_id' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),

 	'b1.id' => array (  // Depot
		'metades' => "",
		'sortformat' => "",
		'listlen' => 4,
		'listlib' => 'b_id', 
		'listlink' => 'on' ,
		'selectlen' => 4,
		'selectlib' => 'b_id', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.name' => array (  // Depot
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'b_name', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'b_name', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.code' => array (  // Depot
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'b_code', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'b_code', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.description' => array (  // Depot
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'b_description', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'b_description', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.icon' => array (  // Depot
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'b_icon', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'b_icon', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.url' => array (  // Depot
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'b_url', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'b_url', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.adress_1' => array (  // Depot
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'b_adress_1', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'b_adress_1', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.adress_2' => array (  // Depot
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'b_adress_2', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'b_adress_2', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.city' => array (  // Depot
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'b_city', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'b_city', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.zip' => array (  // Depot
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'b_zip', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'b_zip', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.country' => array (  // Depot
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'b_country', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'b_country', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.id' => array (  // Documenttype
		'metades' => "",
		'sortformat' => "",
		'listlen' => 4,
		'listlib' => 'c_id', 
		'listlink' => 'on' ,
		'selectlen' => 4,
		'selectlib' => 'c_id', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.name' => array (  // Documenttype
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'c_name', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'c_name', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.code' => array (  // Documenttype
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'c_code', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'c_code', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.description' => array (  // Documenttype
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'c_description', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'c_description', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.icon' => array (  // Documenttype
		'metades' => "",
		'sortformat' => "",
		'listlen' => 12,
		'listlib' => 'c_icon', 
		'listlink' => '' ,
		'selectlen' => 12,
		'selectlib' => 'c_icon', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
) 
			
	];

    /*
        Get field property value
        
        Parameters : field name and property name.
        return : value of property.
    */

	function getMeta( $fieldkey , $metakey ) {
		return $this->colmeta [$fieldkey][$metakey];
	}

    /*
        Get labels for list table header.
        
        Parameters : None.
        return : String.
    */

	function getTableHeaderList() {		
		
		$labelsStr ='';
		
		foreach (  $this->colmeta as $k => $v) {
			if ( $v['listlen'] > 0 ) 
				$labelsStr = $labelsStr.'<th title="'.$v['metades'].'" >'.$v['listlib'] .'</th>'."\n";
		}				
		return $labelsStr;
	}
	
	function getTableFieldLenList( $field ) {		
		
		return $this->colmeta[$field]['listlen'];
	}

	function getTableFieldLinkList( $field ) {		
		
		return $this->colmeta[$field]['listlink'];
	}

    /*
        Get labels for select table header.
        
        Parameters : None.
        return : String.
    */

	function getTableHeaderSelect() {		
		
		$labelsStr ='';
		
		foreach (  $this->colmeta as $k => $v) {
			if ( $v['selectlen'] > 0 ) 
				$labelsStr = $labelsStr.'<th title="'.$v['metades'].'" >'.$v['selectlib'] .'</th>'."\n";
		}				
		return $labelsStr;
	}
	
	function getTableFieldLenSelect( $field ) {		
		
		return $this->colmeta[$field]['selectlen'];
	}

	function getTableFieldLinkSelect( $field ) {		
		
		return $this->colmeta[$field]['selectlink'];
	}

	
    /*
        Check user input values for document.
        
        Parameters : array of fields with regexp  paterns. ex: array( $nom =>'^(?!\s*$).+' , $icone => '')
        return : False if at last one regexp does not match.
    */
    function checkValue( $arrayCheck ) {

        $indexfield=1;
        foreach ( $arrayCheck as $value => $pattern) {

            if ($pattern=='') continue;

            $pattern='/'.$pattern.'/';

            if (!preg_match($pattern, $value)) {
                $this->lasterror = "Erreur champ #".$indexfield. '. Valeur:['.$value.']';
                return false;                
            }

            $indexfield+=1;

        }

        return true;
    }

} // end class

?>
