<?php

/*
		Généalogik
		
        Class for table : event.

        07/03/2021 10:45

        lvardon@laposte.net - 2021
        
        Licence libre

        Usage examples :

        <?php

            include_once("classdir/dbconnect.php);
            include_once("classdir/class_event.php);

            // Class instance
            $myevent = event( $db );

            // Select all reccords :
            $results = $myevent->selectAll();
            foreach($results as $row) {
                print_r($row);
            } 

            // Select reccord #12 :
            $id = 12;
            $row = $myevent->select($id);
            print_r($row);

        ?>

*/
class _event {
      
    public $db;
    public $lasterror="";
    public $lastInsertId=-1;
    public $count = 0;
  
    /*
        Initialise object with dbHanler.
                
    */    
    function __construct( $db ) {
        $this->db = $db;
    }

    /*
        Select one reccord from event.
        
        parameters : $id (reccord id).
        return : associative array of reccord.
    */
    function select($id) {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.name as 'a.name',
			a.description as 'a.description',
			a.private as 'a.private',
			a.date_begin as 'a.date_begin',
			a.date_begin_accurate as 'a.date_begin_accurate',
			a.notesearch as 'a.notesearch',
			a.datecreated as 'a.datecreated',
			a.person_1_id as 'a.person_1_id',
			a.person_2_id as 'a.person_2_id',
			a.person_3_id as 'a.person_3_id',
			a.eventtype_id as 'a.eventtype_id',
			a.place_id as 'a.place_id',

 			b1.id as 'b1.id', 
 			b1.displayname as 'b1.displayname', 
 			b1.description as 'b1.description', 
 			b1.firstname as 'b1.firstname', 
 			b1.lastname as 'b1.lastname', 
 			b1.private as 'b1.private', 
 			b1.icon as 'b1.icon', 
 			b1.sex as 'b1.sex', 
 			b1.notesearch as 'b1.notesearch', 
 			b1.firstnameprefix as 'b1.firstnameprefix', 
 			b1.displaynameprefix as 'b1.displaynameprefix', 
 			b1.lastnamesuffix as 'b1.lastnamesuffix', 
 			b1.surname as 'b1.surname', 
 			b1.datecreated as 'b1.datecreated', 
 			c2.id as 'c2.id', 
 			c2.displayname as 'c2.displayname', 
 			c2.description as 'c2.description', 
 			c2.firstname as 'c2.firstname', 
 			c2.lastname as 'c2.lastname', 
 			c2.private as 'c2.private', 
 			c2.icon as 'c2.icon', 
 			c2.sex as 'c2.sex', 
 			c2.notesearch as 'c2.notesearch', 
 			c2.firstnameprefix as 'c2.firstnameprefix', 
 			c2.displaynameprefix as 'c2.displaynameprefix', 
 			c2.lastnamesuffix as 'c2.lastnamesuffix', 
 			c2.surname as 'c2.surname', 
 			c2.datecreated as 'c2.datecreated', 
 			d3.id as 'd3.id', 
 			d3.displayname as 'd3.displayname', 
 			d3.description as 'd3.description', 
 			d3.firstname as 'd3.firstname', 
 			d3.lastname as 'd3.lastname', 
 			d3.private as 'd3.private', 
 			d3.icon as 'd3.icon', 
 			d3.sex as 'd3.sex', 
 			d3.notesearch as 'd3.notesearch', 
 			d3.firstnameprefix as 'd3.firstnameprefix', 
 			d3.displaynameprefix as 'd3.displaynameprefix', 
 			d3.lastnamesuffix as 'd3.lastnamesuffix', 
 			d3.surname as 'd3.surname', 
 			d3.datecreated as 'd3.datecreated', 
 			e4.id as 'e4.id', 
 			e4.name as 'e4.name', 
 			e4.code as 'e4.code', 
 			e4.category as 'e4.category', 
 			e4.description as 'e4.description', 
 			f5.id as 'f5.id', 
 			f5.name as 'f5.name', 
 			f5.description as 'f5.description', 
 			f5.private as 'f5.private', 
 			f5.icon as 'f5.icon', 
 			f5.adress1 as 'f5.adress1', 
 			f5.adress2 as 'f5.adress2', 
 			f5.zipcode as 'f5.zipcode', 
 			f5.city as 'f5.city', 
 			f5.cityinsee as 'f5.cityinsee', 
 			f5.country as 'f5.country', 
 			f5.url as 'f5.url', 
 			f5.gpslat as 'f5.gpslat', 
 			f5.gpslon as 'f5.gpslon', 
 			f5.datecreated as 'f5.datecreated' 

		from event a 
 			left outer join place f5 on f5.id =  a.place_id 
 			left outer join eventtype e4 on e4.id =  a.eventtype_id 
 			left outer join person d3 on d3.id =  a.person_3_id 
 			left outer join person c2 on c2.id =  a.person_2_id 
 			left outer join person b1 on b1.id =  a.person_1_id 

		where a.id = :id; 
			";

        try {        		

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$idkeyname.')';
            return false;
        }
    }

    function selectPrev($id) {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.name as 'a.name',
			a.description as 'a.description',
			a.private as 'a.private',
			a.date_begin as 'a.date_begin',
			a.date_begin_accurate as 'a.date_begin_accurate',
			a.notesearch as 'a.notesearch',
			a.datecreated as 'a.datecreated',
			a.person_1_id as 'a.person_1_id',
			a.person_2_id as 'a.person_2_id',
			a.person_3_id as 'a.person_3_id',
			a.eventtype_id as 'a.eventtype_id',
			a.place_id as 'a.place_id',

 			b1.id as 'b1.id', 
 			b1.displayname as 'b1.displayname', 
 			b1.description as 'b1.description', 
 			b1.firstname as 'b1.firstname', 
 			b1.lastname as 'b1.lastname', 
 			b1.private as 'b1.private', 
 			b1.icon as 'b1.icon', 
 			b1.sex as 'b1.sex', 
 			b1.notesearch as 'b1.notesearch', 
 			b1.firstnameprefix as 'b1.firstnameprefix', 
 			b1.displaynameprefix as 'b1.displaynameprefix', 
 			b1.lastnamesuffix as 'b1.lastnamesuffix', 
 			b1.surname as 'b1.surname', 
 			b1.datecreated as 'b1.datecreated', 
 			c2.id as 'c2.id', 
 			c2.displayname as 'c2.displayname', 
 			c2.description as 'c2.description', 
 			c2.firstname as 'c2.firstname', 
 			c2.lastname as 'c2.lastname', 
 			c2.private as 'c2.private', 
 			c2.icon as 'c2.icon', 
 			c2.sex as 'c2.sex', 
 			c2.notesearch as 'c2.notesearch', 
 			c2.firstnameprefix as 'c2.firstnameprefix', 
 			c2.displaynameprefix as 'c2.displaynameprefix', 
 			c2.lastnamesuffix as 'c2.lastnamesuffix', 
 			c2.surname as 'c2.surname', 
 			c2.datecreated as 'c2.datecreated', 
 			d3.id as 'd3.id', 
 			d3.displayname as 'd3.displayname', 
 			d3.description as 'd3.description', 
 			d3.firstname as 'd3.firstname', 
 			d3.lastname as 'd3.lastname', 
 			d3.private as 'd3.private', 
 			d3.icon as 'd3.icon', 
 			d3.sex as 'd3.sex', 
 			d3.notesearch as 'd3.notesearch', 
 			d3.firstnameprefix as 'd3.firstnameprefix', 
 			d3.displaynameprefix as 'd3.displaynameprefix', 
 			d3.lastnamesuffix as 'd3.lastnamesuffix', 
 			d3.surname as 'd3.surname', 
 			d3.datecreated as 'd3.datecreated', 
 			e4.id as 'e4.id', 
 			e4.name as 'e4.name', 
 			e4.code as 'e4.code', 
 			e4.category as 'e4.category', 
 			e4.description as 'e4.description', 
 			f5.id as 'f5.id', 
 			f5.name as 'f5.name', 
 			f5.description as 'f5.description', 
 			f5.private as 'f5.private', 
 			f5.icon as 'f5.icon', 
 			f5.adress1 as 'f5.adress1', 
 			f5.adress2 as 'f5.adress2', 
 			f5.zipcode as 'f5.zipcode', 
 			f5.city as 'f5.city', 
 			f5.cityinsee as 'f5.cityinsee', 
 			f5.country as 'f5.country', 
 			f5.url as 'f5.url', 
 			f5.gpslat as 'f5.gpslat', 
 			f5.gpslon as 'f5.gpslon', 
 			f5.datecreated as 'f5.datecreated' 

		from event a 
 			left outer join place f5 on f5.id =  a.place_id 
 			left outer join eventtype e4 on e4.id =  a.eventtype_id 
 			left outer join person d3 on d3.id =  a.person_3_id 
 			left outer join person c2 on c2.id =  a.person_2_id 
 			left outer join person b1 on b1.id =  a.person_1_id 

		where a.id =  (SELECT id FROM event WHERE id < :id ORDER BY id DESC LIMIT 1) ; 
			";

        try {        		

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$idkeyname.')';
            return false;
        }
    }


    function selectNext($id) {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.name as 'a.name',
			a.description as 'a.description',
			a.private as 'a.private',
			a.date_begin as 'a.date_begin',
			a.date_begin_accurate as 'a.date_begin_accurate',
			a.notesearch as 'a.notesearch',
			a.datecreated as 'a.datecreated',
			a.person_1_id as 'a.person_1_id',
			a.person_2_id as 'a.person_2_id',
			a.person_3_id as 'a.person_3_id',
			a.eventtype_id as 'a.eventtype_id',
			a.place_id as 'a.place_id',

 			b1.id as 'b1.id', 
 			b1.displayname as 'b1.displayname', 
 			b1.description as 'b1.description', 
 			b1.firstname as 'b1.firstname', 
 			b1.lastname as 'b1.lastname', 
 			b1.private as 'b1.private', 
 			b1.icon as 'b1.icon', 
 			b1.sex as 'b1.sex', 
 			b1.notesearch as 'b1.notesearch', 
 			b1.firstnameprefix as 'b1.firstnameprefix', 
 			b1.displaynameprefix as 'b1.displaynameprefix', 
 			b1.lastnamesuffix as 'b1.lastnamesuffix', 
 			b1.surname as 'b1.surname', 
 			b1.datecreated as 'b1.datecreated', 
 			c2.id as 'c2.id', 
 			c2.displayname as 'c2.displayname', 
 			c2.description as 'c2.description', 
 			c2.firstname as 'c2.firstname', 
 			c2.lastname as 'c2.lastname', 
 			c2.private as 'c2.private', 
 			c2.icon as 'c2.icon', 
 			c2.sex as 'c2.sex', 
 			c2.notesearch as 'c2.notesearch', 
 			c2.firstnameprefix as 'c2.firstnameprefix', 
 			c2.displaynameprefix as 'c2.displaynameprefix', 
 			c2.lastnamesuffix as 'c2.lastnamesuffix', 
 			c2.surname as 'c2.surname', 
 			c2.datecreated as 'c2.datecreated', 
 			d3.id as 'd3.id', 
 			d3.displayname as 'd3.displayname', 
 			d3.description as 'd3.description', 
 			d3.firstname as 'd3.firstname', 
 			d3.lastname as 'd3.lastname', 
 			d3.private as 'd3.private', 
 			d3.icon as 'd3.icon', 
 			d3.sex as 'd3.sex', 
 			d3.notesearch as 'd3.notesearch', 
 			d3.firstnameprefix as 'd3.firstnameprefix', 
 			d3.displaynameprefix as 'd3.displaynameprefix', 
 			d3.lastnamesuffix as 'd3.lastnamesuffix', 
 			d3.surname as 'd3.surname', 
 			d3.datecreated as 'd3.datecreated', 
 			e4.id as 'e4.id', 
 			e4.name as 'e4.name', 
 			e4.code as 'e4.code', 
 			e4.category as 'e4.category', 
 			e4.description as 'e4.description', 
 			f5.id as 'f5.id', 
 			f5.name as 'f5.name', 
 			f5.description as 'f5.description', 
 			f5.private as 'f5.private', 
 			f5.icon as 'f5.icon', 
 			f5.adress1 as 'f5.adress1', 
 			f5.adress2 as 'f5.adress2', 
 			f5.zipcode as 'f5.zipcode', 
 			f5.city as 'f5.city', 
 			f5.cityinsee as 'f5.cityinsee', 
 			f5.country as 'f5.country', 
 			f5.url as 'f5.url', 
 			f5.gpslat as 'f5.gpslat', 
 			f5.gpslon as 'f5.gpslon', 
 			f5.datecreated as 'f5.datecreated' 

		from event a 
 			left outer join place f5 on f5.id =  a.place_id 
 			left outer join eventtype e4 on e4.id =  a.eventtype_id 
 			left outer join person d3 on d3.id =  a.person_3_id 
 			left outer join person c2 on c2.id =  a.person_2_id 
 			left outer join person b1 on b1.id =  a.person_1_id 

		where a.id =  (SELECT id FROM event WHERE id > :id ORDER BY id ASC LIMIT 1) ; 
			";

        try {        		

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$idkeyname.')';
            return false;
        }
    }

    /*
        Select all reccords from event  (with default order).
        
        parameters : None
        return : associative array of reccords.
    */
    function selectAll() {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.name as 'a.name',
			a.description as 'a.description',
			a.private as 'a.private',
			a.date_begin as 'a.date_begin',
			a.date_begin_accurate as 'a.date_begin_accurate',
			a.notesearch as 'a.notesearch',
			a.datecreated as 'a.datecreated',
			a.person_1_id as 'a.person_1_id',
			a.person_2_id as 'a.person_2_id',
			a.person_3_id as 'a.person_3_id',
			a.eventtype_id as 'a.eventtype_id',
			a.place_id as 'a.place_id',

 			b1.id as 'b1.id',
 			b1.displayname as 'b1.displayname',
 			b1.description as 'b1.description',
 			b1.firstname as 'b1.firstname',
 			b1.lastname as 'b1.lastname',
 			b1.private as 'b1.private',
 			b1.icon as 'b1.icon',
 			b1.sex as 'b1.sex',
 			b1.notesearch as 'b1.notesearch',
 			b1.firstnameprefix as 'b1.firstnameprefix',
 			b1.displaynameprefix as 'b1.displaynameprefix',
 			b1.lastnamesuffix as 'b1.lastnamesuffix',
 			b1.surname as 'b1.surname',
 			b1.datecreated as 'b1.datecreated',
 			c2.id as 'c2.id',
 			c2.displayname as 'c2.displayname',
 			c2.description as 'c2.description',
 			c2.firstname as 'c2.firstname',
 			c2.lastname as 'c2.lastname',
 			c2.private as 'c2.private',
 			c2.icon as 'c2.icon',
 			c2.sex as 'c2.sex',
 			c2.notesearch as 'c2.notesearch',
 			c2.firstnameprefix as 'c2.firstnameprefix',
 			c2.displaynameprefix as 'c2.displaynameprefix',
 			c2.lastnamesuffix as 'c2.lastnamesuffix',
 			c2.surname as 'c2.surname',
 			c2.datecreated as 'c2.datecreated',
 			d3.id as 'd3.id',
 			d3.displayname as 'd3.displayname',
 			d3.description as 'd3.description',
 			d3.firstname as 'd3.firstname',
 			d3.lastname as 'd3.lastname',
 			d3.private as 'd3.private',
 			d3.icon as 'd3.icon',
 			d3.sex as 'd3.sex',
 			d3.notesearch as 'd3.notesearch',
 			d3.firstnameprefix as 'd3.firstnameprefix',
 			d3.displaynameprefix as 'd3.displaynameprefix',
 			d3.lastnamesuffix as 'd3.lastnamesuffix',
 			d3.surname as 'd3.surname',
 			d3.datecreated as 'd3.datecreated',
 			e4.id as 'e4.id',
 			e4.name as 'e4.name',
 			e4.code as 'e4.code',
 			e4.category as 'e4.category',
 			e4.description as 'e4.description',
 			f5.id as 'f5.id',
 			f5.name as 'f5.name',
 			f5.description as 'f5.description',
 			f5.private as 'f5.private',
 			f5.icon as 'f5.icon',
 			f5.adress1 as 'f5.adress1',
 			f5.adress2 as 'f5.adress2',
 			f5.zipcode as 'f5.zipcode',
 			f5.city as 'f5.city',
 			f5.cityinsee as 'f5.cityinsee',
 			f5.country as 'f5.country',
 			f5.url as 'f5.url',
 			f5.gpslat as 'f5.gpslat',
 			f5.gpslon as 'f5.gpslon',
 			f5.datecreated as 'f5.datecreated'

		from event a 
 			left outer join place f5 on f5.id =  a.place_id 
 			left outer join eventtype e4 on e4.id =  a.eventtype_id 
 			left outer join person d3 on d3.id =  a.person_3_id 
 			left outer join person c2 on c2.id =  a.person_2_id 
 			left outer join person b1 on b1.id =  a.person_1_id 

		;    
                ";

        try {        

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);           
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage();
            $this->count = 0;
            return false;
        }
    }

    /*
        Update event 
        
        parameters : $id (reccord id) and fields list values.
        return : True if no error.
    */
    function update( $id, $name,$description,$private,$date_begin,$date_begin_accurate,$notesearch,$datecreated,$person_1_id,$person_2_id,$person_3_id,$eventtype_id,$place_id ) {

        $this->lasterror="";        

		if ($name == '') $name = null;
		if ($description == '') $description = null;
		if ($private == '') $private = null;
		if ($date_begin == '') $date_begin = null;
		if ($date_begin_accurate == '') $date_begin_accurate = null;
		if ($notesearch == '') $notesearch = null;
		if ($datecreated == '') $datecreated = null;
		if ($person_1_id == '') $person_1_id = null;
		if ($person_2_id == '') $person_2_id = null;
		if ($person_3_id == '') $person_3_id = null;
		if ($eventtype_id == '') $eventtype_id = null;
		if ($place_id == '') $place_id = null;
		

        if ($this->checkValue( array( 
		$name => '',
		$description => '',
		$private => '',
		$date_begin => '',
		$date_begin_accurate => '',
		$notesearch => '',
		$datecreated => '',
		$person_1_id => '',
		$person_2_id => '',
		$person_3_id => '',
		$eventtype_id => '',
		$place_id => ''

) ) == false )
        {
            $this->lasterror="Check fields false";        
            return false;
        }

        $sqlSt="
		update event set
			name = :name,
			description = :description,
			private = :private,
			date_begin = :date_begin,
			date_begin_accurate = :date_begin_accurate,
			notesearch = :notesearch,
			datecreated = :datecreated,
			person_1_id = :person_1_id,
			person_2_id = :person_2_id,
			person_3_id = :person_3_id,
			eventtype_id = :eventtype_id,
			place_id = :place_id

		where id = :id; 
            ";

        try {        
            
            $stmt = $this->db->prepare($sqlSt);
            
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);

			$stmt->bindParam(':name', $name, PDO::PARAM_STR); 
			$stmt->bindParam(':description', $description, PDO::PARAM_STR); 
			$stmt->bindParam(':private', $private, PDO::PARAM_INT); 
			$stmt->bindParam(':date_begin', $date_begin, PDO::PARAM_STR); 
			$stmt->bindParam(':date_begin_accurate', $date_begin_accurate, PDO::PARAM_STR); 
			$stmt->bindParam(':notesearch', $notesearch, PDO::PARAM_STR); 
			$stmt->bindParam(':datecreated', $datecreated, PDO::PARAM_STR); 
			$stmt->bindParam(':person_1_id', $person_1_id, PDO::PARAM_INT); 
			$stmt->bindParam(':person_2_id', $person_2_id, PDO::PARAM_INT); 
			$stmt->bindParam(':person_3_id', $person_3_id, PDO::PARAM_INT); 
			$stmt->bindParam(':eventtype_id', $eventtype_id, PDO::PARAM_INT); 
			$stmt->bindParam(':place_id', $place_id, PDO::PARAM_INT); 
 
            $stmt->execute();             
            
            if ($stmt->rowCount() == 0) {
				$this->lasterror = 'Erreur Sql update '.'  (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>name</b> = [$name],<b>description</b> = [$description],<b>private</b> = [$private],<b>date_begin</b> = [$date_begin],<b>date_begin_accurate</b> = [$date_begin_accurate],<b>notesearch</b> = [$notesearch],<b>datecreated</b> = [$datecreated],<b>person_1_id</b> = [$person_1_id],<b>person_2_id</b> = [$person_2_id],<b>person_3_id</b> = [$person_3_id],<b>eventtype_id</b> = [$eventtype_id],<b>place_id</b> = [$place_id]";
				
				return false;
			}   
			         
            return true;

        } catch (Exception $e) {            
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>name</b> = [$name],<b>description</b> = [$description],<b>private</b> = [$private],<b>date_begin</b> = [$date_begin],<b>date_begin_accurate</b> = [$date_begin_accurate],<b>notesearch</b> = [$notesearch],<b>datecreated</b> = [$datecreated],<b>person_1_id</b> = [$person_1_id],<b>person_2_id</b> = [$person_2_id],<b>person_3_id</b> = [$person_3_id],<b>eventtype_id</b> = [$eventtype_id],<b>place_id</b> = [$place_id]";  
            return false;
        }

    }

    /*
        Insert new reccord into event.
        
        Parameters : fields values list.
        return : True if no error.
    */
    function insert( $name,$description,$private,$date_begin,$date_begin_accurate,$notesearch,$datecreated,$person_1_id,$person_2_id,$person_3_id,$eventtype_id,$place_id ) {

        $this->lasterror="";
        $this->lastInsertId = -1;

		if ($name == '') $name = null;
		if ($description == '') $description = null;
		if ($private == '') $private = null;
		if ($date_begin == '') $date_begin = null;
		if ($date_begin_accurate == '') $date_begin_accurate = null;
		if ($notesearch == '') $notesearch = null;
		if ($datecreated == '') $datecreated = null;
		if ($person_1_id == '') $person_1_id = null;
		if ($person_2_id == '') $person_2_id = null;
		if ($person_3_id == '') $person_3_id = null;
		if ($eventtype_id == '') $eventtype_id = null;
		if ($place_id == '') $place_id = null;
		
		
        if ($this->checkValue( array( 
		$name => '',
		$description => '',
		$private => '',
		$date_begin => '',
		$date_begin_accurate => '',
		$notesearch => '',
		$datecreated => '',
		$person_1_id => '',
		$person_2_id => '',
		$person_3_id => '',
		$eventtype_id => '',
		$place_id => ''

) ) == false )
        {
            $this->lasterror="Check fields error";        
            return false;
        }

        $sqlSt="
		insert into event (
		name,
		description,
		private,
		date_begin,
		date_begin_accurate,
		notesearch,
		datecreated,
		person_1_id,
		person_2_id,
		person_3_id,
		eventtype_id,
		place_id
 
			)
		values (
		:name, 
		:description, 
		:private, 
		:date_begin, 
		:date_begin_accurate, 
		:notesearch, 
		:datecreated, 
		:person_1_id, 
		:person_2_id, 
		:person_3_id, 
		:eventtype_id, 
		:place_id 
 
			);    
            ";

        try {        

            $stmt = $this->db->prepare($sqlSt);               
			
			$stmt->bindParam(':name', $name, PDO::PARAM_STR); 
			$stmt->bindParam(':description', $description, PDO::PARAM_STR); 
			$stmt->bindParam(':private', $private, PDO::PARAM_INT); 
			$stmt->bindParam(':date_begin', $date_begin, PDO::PARAM_STR); 
			$stmt->bindParam(':date_begin_accurate', $date_begin_accurate, PDO::PARAM_STR); 
			$stmt->bindParam(':notesearch', $notesearch, PDO::PARAM_STR); 
			$stmt->bindParam(':datecreated', $datecreated, PDO::PARAM_STR); 
			$stmt->bindParam(':person_1_id', $person_1_id, PDO::PARAM_INT); 
			$stmt->bindParam(':person_2_id', $person_2_id, PDO::PARAM_INT); 
			$stmt->bindParam(':person_3_id', $person_3_id, PDO::PARAM_INT); 
			$stmt->bindParam(':eventtype_id', $eventtype_id, PDO::PARAM_INT); 
			$stmt->bindParam(':place_id', $place_id, PDO::PARAM_INT); 
 

            $stmt->execute();     
            $this->lastInsertId = $this->db->lastInsertId(); 
            
            if ($stmt->rowCount() == 0) {
				$this->lasterror = 'Erreur Sql insert'.'  (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>name</b> = [$name],<b>description</b> = [$description],<b>private</b> = [$private],<b>date_begin</b> = [$date_begin],<b>date_begin_accurate</b> = [$date_begin_accurate],<b>notesearch</b> = [$notesearch],<b>datecreated</b> = [$datecreated],<b>person_1_id</b> = [$person_1_id],<b>person_2_id</b> = [$person_2_id],<b>person_3_id</b> = [$person_3_id],<b>eventtype_id</b> = [$eventtype_id],<b>place_id</b> = [$place_id]";
				return false;
			}              
                   
            return true;

        } catch (Exception $e) {
             $this->lasterror = $e->getMessage().'  (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>name</b> = [$name],<b>description</b> = [$description],<b>private</b> = [$private],<b>date_begin</b> = [$date_begin],<b>date_begin_accurate</b> = [$date_begin_accurate],<b>notesearch</b> = [$notesearch],<b>datecreated</b> = [$datecreated],<b>person_1_id</b> = [$person_1_id],<b>person_2_id</b> = [$person_2_id],<b>person_3_id</b> = [$person_3_id],<b>eventtype_id</b> = [$eventtype_id],<b>place_id</b> = [$place_id]";
            return false;
        }
    }

    /*
        Delete one reccord from event.
        
        parameters : $id (reccord id).
        return : True if no error.
    */
    function delete($id) {

        $this->lasterror="";

        $sqlSt="
		delete from event             
		where id = :id; 
            ";   
     
        try {        

            $stmt = $this->db->prepare($sqlSt);  
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute();        
            
			if ($stmt->rowCount() == 0) {
				$this->lasterror = "Erreur Sql delete ".' (<b>Id</b> ='.$id.')';       
				return false;
			}              

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b>='.$id.')';
            return false;
        }
        return true;
    }

    /*
        Get id min, id max, record count from event  
        
        parameters : None
        return : count value or False in case of error
    */
	function getCount() {
		
        $this->lasterror="";

        $sqlSt="
		select min(id) as minid, max(id) as maxid, count(*) as count 
		from event 
                ";

        try {        

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC); 
            return $results[0];          

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage();
            return array( 'minid' => -1, 'maxid' => -1, 'count' => -1);
        }
        		
		//return $this->count;
		return $results[0];
	}




	public $colmeta = [
	'a.id' => array (
		'metades' => "",
		'sortformat' => "{{sortformat}}",
		'listlen' => 4,
		'listlib' => 'a_id',
		'listlink' => 'on',
		'selectlen' => 4,
		'selectlib' => 'a_id',
		'selectlink' => '',
		'selectdisplay' => '',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => '', 
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 

		),
	'a.name' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 24,
		'listlib' => 'a_name' , 
		'listlink' => '',
		'selectlen' => 12,
		'selectlib' => 'a_name' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.description' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'a_description' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'a_description' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.private' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'a_private' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'a_private' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.date_begin' => array ( 
		'metades' => "",
		'sortformat' => "date", 
		'listlen' => 9,
		'listlib' => 'a_date_begin' , 
		'listlink' => '',
		'selectlen' => 9,
		'selectlib' => 'a_date_begin' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.date_begin_accurate' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'a_date_begin_accurate' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'a_date_begin_accurate' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.notesearch' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'a_notesearch' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'a_notesearch' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.datecreated' => array ( 
		'metades' => "",
		'sortformat' => "date", 
		'listlen' => 4,
		'listlib' => 'a_datecreated' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'a_datecreated' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.person_1_id' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 4,
		'listlib' => 'a_person_1_id' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'a_person_1_id' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.person_2_id' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 4,
		'listlib' => 'a_person_2_id' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'a_person_2_id' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.person_3_id' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 4,
		'listlib' => 'a_person_3_id' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'a_person_3_id' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.eventtype_id' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 4,
		'listlib' => 'a_eventtype_id' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'a_eventtype_id' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.place_id' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 4,
		'listlib' => 'a_place_id' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'a_place_id' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),

 	'b1.id' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'id', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'id', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.displayname' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'displayname', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'displayname', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.description' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'description', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'description', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.firstname' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'firstname', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'firstname', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.lastname' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'lastname', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'lastname', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.private' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'private', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'private', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.icon' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 8,
		'listlib' => 'icon', 
		'listlink' => '' ,
		'selectlen' => 8,
		'selectlib' => 'icon', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.sex' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'sex', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'sex', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.notesearch' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'notesearch', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'notesearch', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.firstnameprefix' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'firstnameprefix', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'firstnameprefix', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.displaynameprefix' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'displaynameprefix', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'displaynameprefix', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.lastnamesuffix' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'lastnamesuffix', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'lastnamesuffix', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.surname' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'surname', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'surname', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.datecreated' => array (  // Person
		'metades' => "",
		'sortformat' => "date",
		'listlen' => 0,
		'listlib' => 'datecreated', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'datecreated', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.id' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'id', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'id', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.displayname' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'displayname', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'displayname', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.description' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 8,
		'listlib' => 'description', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'description', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.firstname' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'firstname', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'firstname', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.lastname' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'lastname', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'lastname', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.private' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'private', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'private', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.icon' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'icon', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'icon', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.sex' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'sex', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'sex', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.notesearch' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'notesearch', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'notesearch', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.firstnameprefix' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'firstnameprefix', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'firstnameprefix', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.displaynameprefix' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'displaynameprefix', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'displaynameprefix', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.lastnamesuffix' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'lastnamesuffix', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'lastnamesuffix', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.surname' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'surname', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'surname', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'c2.datecreated' => array (  // Person
		'metades' => "",
		'sortformat' => "date",
		'listlen' => 0,
		'listlib' => 'datecreated', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'datecreated', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.id' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'id', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'id', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.displayname' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'displayname', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'displayname', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.description' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'description', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'description', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.firstname' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'firstname', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'firstname', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.lastname' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'lastname', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'lastname', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.private' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'private', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'private', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.icon' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'icon', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'icon', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.sex' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'sex', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'sex', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.notesearch' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'notesearch', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'notesearch', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.firstnameprefix' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'firstnameprefix', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'firstnameprefix', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.displaynameprefix' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'displaynameprefix', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'displaynameprefix', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.lastnamesuffix' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'lastnamesuffix', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'lastnamesuffix', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.surname' => array (  // Person
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'surname', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'surname', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'd3.datecreated' => array (  // Person
		'metades' => "",
		'sortformat' => "date",
		'listlen' => 0,
		'listlib' => 'datecreated', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'datecreated', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'e4.id' => array (  // Eventtype
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'id', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'id', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'e4.name' => array (  // Eventtype
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'name', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'name', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'e4.code' => array (  // Eventtype
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'code', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'code', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'e4.category' => array (  // Eventtype
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'category', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'category', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'e4.description' => array (  // Eventtype
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'description', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'description', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.id' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'id', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'id', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.name' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'name', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'name', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.description' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'description', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'description', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.private' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'private', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'private', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.icon' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'icon', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'icon', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.adress1' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'adress1', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'adress1', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.adress2' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'adress2', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'adress2', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.zipcode' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'zipcode', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'zipcode', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.city' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'city', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'city', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.cityinsee' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'cityinsee', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'cityinsee', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.country' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'country', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'country', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.url' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'url', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'url', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.gpslat' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'gpslat', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'gpslat', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.gpslon' => array (  // Place
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'gpslon', 
		'listlink' => '' ,
		'selectlen' => 0,
		'selectlib' => 'gpslon', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'f5.datecreated' => array (  // Place
		'metades' => "",
		'sortformat' => "date",
		'listlen' => 0,
		'listlib' => 'datecreated', 
		'listlink' => '' ,
		'selectlen' => 8,
		'selectlib' => 'datecreated', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
) 
			
	];

    /*
        Get field property value
        
        Parameters : field name and property name.
        return : value of property.
    */

	function getMeta( $fieldkey , $metakey ) {
		return $this->colmeta [$fieldkey][$metakey];
	}

    /*
        Get labels for list table header.
        
        Parameters : None.
        return : String.
    */

	function getTableHeaderList() {		
		
		$labelsStr ='';
		
		foreach (  $this->colmeta as $k => $v) {
			if ( $v['listlen'] > 0 ) 
				$labelsStr = $labelsStr.'<th title="'.$v['metades'].'" >'.$v['listlib'] .'</th>'."\n";
		}				
		return $labelsStr;
	}
	
	function getTableFieldLenList( $field ) {		
		
		return $this->colmeta[$field]['listlen'];
	}

	function getTableFieldLinkList( $field ) {		
		
		return $this->colmeta[$field]['listlink'];
	}

    /*
        Get labels for select table header.
        
        Parameters : None.
        return : String.
    */

	function getTableHeaderSelect() {		
		
		$labelsStr ='';
		
		foreach (  $this->colmeta as $k => $v) {
			if ( $v['selectlen'] > 0 ) 
				$labelsStr = $labelsStr.'<th title="'.$v['metades'].'" >'.$v['selectlib'] .'</th>'."\n";
		}				
		return $labelsStr;
	}
	
	function getTableFieldLenSelect( $field ) {		
		
		return $this->colmeta[$field]['selectlen'];
	}

	function getTableFieldLinkSelect( $field ) {		
		
		return $this->colmeta[$field]['selectlink'];
	}

	
    /*
        Check user input values for event.
        
        Parameters : array of fields with regexp  paterns. ex: array( $nom =>'^(?!\s*$).+' , $icone => '')
        return : False if at last one regexp does not match.
    */
    function checkValue( $arrayCheck ) {

        $indexfield=1;
        foreach ( $arrayCheck as $value => $pattern) {

            if ($pattern=='') continue;

            $pattern='/'.$pattern.'/';

            if (!preg_match($pattern, $value)) {
                $this->lasterror = "Erreur champ #".$indexfield. '. Valeur:['.$value.']';
                return false;                
            }

            $indexfield+=1;

        }

        return true;
    }

} // end class

?>
